// For the `@tape` annotation, see the `TapeApi`.

/// Annotating a field in a `@tape` class with `@TapeField` indicates that it
/// should be included in the code of the generated `Taper`.
class TapeField {
  const TapeField({this.name, this.defaultValue});

  final String name;
  final dynamic defaultValue;
}

/// Annotating a field of a `@tape` class with `@doNotTape` indicates that the
/// generated `Taper` shouldn't serialize it.
const doNotTape = DoNotTape();

class DoNotTape {
  const DoNotTape();
}
