/// If an exact type can't be encoded, we suggest adding an adapter. Here, we
/// keep track of which adapters we suggested along with the suggested id.
final _suggestedTapers = <String, int>{};

String taperSuggestion(Type type) {
  final suggestedId = _suggestedAdapters[type.toString()] ??
      (_adaptersByIds.isEmpty
          ? 0
          : _adaptersByIds.keys.reduce(max) + 1 + _suggestedAdapters.length);
  _suggestedAdapters[type.toString()] = suggestedId;

  return 'AdapterFor$type().registerForId($suggestedId)';
}
