import 'package:meta/meta.dart';

import '../blocks/blocks.dart';
import 'registry.dart';

@immutable
abstract class Taper<T> {
  const Taper();

  Type get type => T;

  /// Registers this adapter for the given [typeCode] on the registry.
  void registerForTypeCode(int typeCode) {
    registry.registerSingle<T>(typeCode, this);
  }

  Block toBlock(T object);
  T fromBlock(Block block);
}
